require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_ATOMIC_H)) {
    eval 'sub _ASM_IA64_ATOMIC_H () {1;}' unless defined(&_ASM_IA64_ATOMIC_H);
    require 'linux/types.ph';
    require 'asm/intrinsics.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub ATOMIC_INIT {
	    local($i) = @_;
    	    eval q((( &atomic_t) { ($i) }));
	}' unless defined(&ATOMIC_INIT);
	eval 'sub ATOMIC64_INIT {
	    local($i) = @_;
    	    eval q((( &atomic64_t) { ($i) }));
	}' unless defined(&ATOMIC64_INIT);
	eval 'sub atomic_read {
	    local($v) = @_;
    	    eval q((($v)-> &counter));
	}' unless defined(&atomic_read);
	eval 'sub atomic64_read {
	    local($v) = @_;
    	    eval q((($v)-> &counter));
	}' unless defined(&atomic64_read);
	eval 'sub atomic_set {
	    local($v,$i) = @_;
    	    eval q(((($v)-> &counter) = ($i)));
	}' unless defined(&atomic_set);
	eval 'sub atomic64_set {
	    local($v,$i) = @_;
    	    eval q(((($v)-> &counter) = ($i)));
	}' unless defined(&atomic64_set);
	eval 'sub atomic_add_return {
	    local($i,$v) = @_;
    	    eval q(({ \'int\'  &__ia64_aar_i = ($i); ( &__builtin_constant_p($i)  && ( ( &__ia64_aar_i == 1) || ( &__ia64_aar_i == 4) || ( &__ia64_aar_i == 8) || ( &__ia64_aar_i == 16) || ( &__ia64_aar_i == -1) || ( &__ia64_aar_i == -4) || ( &__ia64_aar_i == -8) || ( &__ia64_aar_i == -16))) ?  &ia64_fetch_and_add( &__ia64_aar_i, ($v)-> &counter) :  &ia64_atomic_add( &__ia64_aar_i, $v); }));
	}' unless defined(&atomic_add_return);
	eval 'sub atomic64_add_return {
	    local($i,$v) = @_;
    	    eval q(({ \'long __ia64_aar_i\' = ($i); ( &__builtin_constant_p($i)  && ( ( &__ia64_aar_i == 1) || ( &__ia64_aar_i == 4) || ( &__ia64_aar_i == 8) || ( &__ia64_aar_i == 16) || ( &__ia64_aar_i == -1) || ( &__ia64_aar_i == -4) || ( &__ia64_aar_i == -8) || ( &__ia64_aar_i == -16))) ?  &ia64_fetch_and_add( &__ia64_aar_i, ($v)-> &counter) :  &ia64_atomic64_add( &__ia64_aar_i, $v); }));
	}' unless defined(&atomic64_add_return);
	eval 'sub atomic_sub_return {
	    local($i,$v) = @_;
    	    eval q(({ \'int\'  &__ia64_asr_i = ($i); ( &__builtin_constant_p($i)  && ( ( &__ia64_asr_i == 1) || ( &__ia64_asr_i == 4) || ( &__ia64_asr_i == 8) || ( &__ia64_asr_i == 16) || ( &__ia64_asr_i == -1) || ( &__ia64_asr_i == -4) || ( &__ia64_asr_i == -8) || ( &__ia64_asr_i == -16))) ?  &ia64_fetch_and_add(- &__ia64_asr_i, ($v)-> &counter) :  &ia64_atomic_sub( &__ia64_asr_i, $v); }));
	}' unless defined(&atomic_sub_return);
	eval 'sub atomic64_sub_return {
	    local($i,$v) = @_;
    	    eval q(({ \'long __ia64_asr_i\' = ($i); ( &__builtin_constant_p($i)  && ( ( &__ia64_asr_i == 1) || ( &__ia64_asr_i == 4) || ( &__ia64_asr_i == 8) || ( &__ia64_asr_i == 16) || ( &__ia64_asr_i == -1) || ( &__ia64_asr_i == -4) || ( &__ia64_asr_i == -8) || ( &__ia64_asr_i == -16))) ?  &ia64_fetch_and_add(- &__ia64_asr_i, ($v)-> &counter) :  &ia64_atomic64_sub( &__ia64_asr_i, $v); }));
	}' unless defined(&atomic64_sub_return);
	eval 'sub atomic_dec_return {
	    local($v) = @_;
    	    eval q( &atomic_sub_return(1, ($v)));
	}' unless defined(&atomic_dec_return);
	eval 'sub atomic_inc_return {
	    local($v) = @_;
    	    eval q( &atomic_add_return(1, ($v)));
	}' unless defined(&atomic_inc_return);
	eval 'sub atomic64_dec_return {
	    local($v) = @_;
    	    eval q( &atomic64_sub_return(1, ($v)));
	}' unless defined(&atomic64_dec_return);
	eval 'sub atomic64_inc_return {
	    local($v) = @_;
    	    eval q( &atomic64_add_return(1, ($v)));
	}' unless defined(&atomic64_inc_return);
	eval 'sub atomic_sub_and_test {
	    local($i,$v) = @_;
    	    eval q(( &atomic_sub_return(($i), ($v)) == 0));
	}' unless defined(&atomic_sub_and_test);
	eval 'sub atomic_dec_and_test {
	    local($v) = @_;
    	    eval q(( &atomic_sub_return(1, ($v)) == 0));
	}' unless defined(&atomic_dec_and_test);
	eval 'sub atomic_inc_and_test {
	    local($v) = @_;
    	    eval q(( &atomic_add_return(1, ($v)) != 0));
	}' unless defined(&atomic_inc_and_test);
	eval 'sub atomic64_sub_and_test {
	    local($i,$v) = @_;
    	    eval q(( &atomic64_sub_return(($i), ($v)) == 0));
	}' unless defined(&atomic64_sub_and_test);
	eval 'sub atomic64_dec_and_test {
	    local($v) = @_;
    	    eval q(( &atomic64_sub_return(1, ($v)) == 0));
	}' unless defined(&atomic64_dec_and_test);
	eval 'sub atomic64_inc_and_test {
	    local($v) = @_;
    	    eval q(( &atomic64_add_return(1, ($v)) != 0));
	}' unless defined(&atomic64_inc_and_test);
	eval 'sub atomic_add {
	    local($i,$v) = @_;
    	    eval q( &atomic_add_return(($i), ($v)));
	}' unless defined(&atomic_add);
	eval 'sub atomic_sub {
	    local($i,$v) = @_;
    	    eval q( &atomic_sub_return(($i), ($v)));
	}' unless defined(&atomic_sub);
	eval 'sub atomic_inc {
	    local($v) = @_;
    	    eval q( &atomic_add(1, ($v)));
	}' unless defined(&atomic_inc);
	eval 'sub atomic_dec {
	    local($v) = @_;
    	    eval q( &atomic_sub(1, ($v)));
	}' unless defined(&atomic_dec);
	eval 'sub atomic64_add {
	    local($i,$v) = @_;
    	    eval q( &atomic64_add_return(($i), ($v)));
	}' unless defined(&atomic64_add);
	eval 'sub atomic64_sub {
	    local($i,$v) = @_;
    	    eval q( &atomic64_sub_return(($i), ($v)));
	}' unless defined(&atomic64_sub);
	eval 'sub atomic64_inc {
	    local($v) = @_;
    	    eval q( &atomic64_add(1, ($v)));
	}' unless defined(&atomic64_inc);
	eval 'sub atomic64_dec {
	    local($v) = @_;
    	    eval q( &atomic64_sub(1, ($v)));
	}' unless defined(&atomic64_dec);
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_atomic_inc);
    }
}
1;
