require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_BITOPS_H)) {
    eval 'sub _ASM_IA64_BITOPS_H () {1;}' unless defined(&_ASM_IA64_BITOPS_H);
    require 'linux/compiler.ph';
    require 'linux/types.ph';
    require 'asm/intrinsics.ph';
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &do { ; }  &while (0));
    }' unless defined(&smp_mb__after_clear_bit);
    if(defined(&__KERNEL__)) {
	eval 'sub ffs {
	    local($x) = @_;
    	    eval q( &__builtin_ffs($x));
	}' unless defined(&ffs);
	eval 'sub hweight32 {
	    local($x) = @_;
    	    eval q( &hweight64 (($x) & 0xffffffff));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    local($x) = @_;
    	    eval q( &hweight64 (($x) & 0xffff));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    local($x) = @_;
    	    eval q( &hweight64 (($x) & 0xff));
	}' unless defined(&hweight8);
    }
    eval 'sub find_first_zero_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_bit);
    eval 'sub find_first_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_bit(($addr), ($size), 0));
    }' unless defined(&find_first_bit);
    if(defined(&__KERNEL__)) {
	eval 'sub __clear_bit {
	    local($nr, $addr) = @_;
    	    eval q( &clear_bit($nr, $addr));
	}' unless defined(&__clear_bit);
	eval 'sub ext2_set_bit () { &test_and_set_bit;}' unless defined(&ext2_set_bit);
	eval 'sub ext2_set_bit_atomic {
	    local($l,$n,$a) = @_;
    	    eval q( &test_and_set_bit($n,$a));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit () { &test_and_clear_bit;}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_clear_bit_atomic {
	    local($l,$n,$a) = @_;
    	    eval q( &test_and_clear_bit($n,$a));
	}' unless defined(&ext2_clear_bit_atomic);
	eval 'sub ext2_test_bit () { &test_bit;}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit () { &find_first_zero_bit;}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit () { &find_next_zero_bit;}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_set_bit($nr,$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &set_bit($nr,$addr));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit($nr,$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_bit($nr,$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    local($addr,$size) = @_;
    	    eval q( &find_first_zero_bit($addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
