require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_PTRACE_H)) {
    eval 'sub _ASM_IA64_PTRACE_H () {1;}' unless defined(&_ASM_IA64_PTRACE_H);
    require 'linux/config.ph';
    require 'asm/fpu.ph';
    require 'asm/offsets.ph';
    if(defined( &CONFIG_IA64_PAGE_SIZE_4KB)) {
	eval 'sub KERNEL_STACK_SIZE_ORDER () {3;}' unless defined(&KERNEL_STACK_SIZE_ORDER);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_8KB)) {
	eval 'sub KERNEL_STACK_SIZE_ORDER () {2;}' unless defined(&KERNEL_STACK_SIZE_ORDER);
    }
 elsif(defined( &CONFIG_IA64_PAGE_SIZE_16KB)) {
	eval 'sub KERNEL_STACK_SIZE_ORDER () {1;}' unless defined(&KERNEL_STACK_SIZE_ORDER);
    } else {
	eval 'sub KERNEL_STACK_SIZE_ORDER () {0;}' unless defined(&KERNEL_STACK_SIZE_ORDER);
    }
    eval 'sub IA64_RBS_OFFSET () {(( &IA64_TASK_SIZE +  &IA64_THREAD_INFO_SIZE + 15) & ~15);}' unless defined(&IA64_RBS_OFFSET);
    eval 'sub IA64_STK_OFFSET () {((1<<  &KERNEL_STACK_SIZE_ORDER)* &PAGE_SIZE);}' unless defined(&IA64_STK_OFFSET);
    eval 'sub KERNEL_STACK_SIZE () { &IA64_STK_OFFSET;}' unless defined(&KERNEL_STACK_SIZE);
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/current.ph';
	require 'asm/page.ph';
	if(defined(&__KERNEL__)) {
	    eval 'sub instruction_pointer {
	        local($regs) = @_;
    		eval q((($regs)-> &cr_iip +  &ia64_psr($regs)-> &ri));
	    }' unless defined(&instruction_pointer);
	    eval 'sub ia64_task_regs {
	        local($t) = @_;
    		eval q((( ( ($t) +  &IA64_STK_OFFSET)) - 1));
	    }' unless defined(&ia64_task_regs);
	    eval 'sub ia64_psr {
	        local($regs) = @_;
    		eval q(( ($regs)-> &cr_ipsr));
	    }' unless defined(&ia64_psr);
	    eval 'sub user_mode {
	        local($regs) = @_;
    		eval q((( ($regs)-> &cr_ipsr)-> &cpl != 0));
	    }' unless defined(&user_mode);
	    eval 'sub user_stack {
	        local($task,$regs) = @_;
    		eval q(( $regs - $task ==  &IA64_STK_OFFSET - $sizeof{$regs}));
	    }' unless defined(&user_stack);
	    eval 'sub fsys_mode {
	        local($task,$regs) = @_;
    		eval q(({ 1; 1; ! &user_mode( &_regs)  &&  &user_stack( &_task,  &_regs); }));
	    }' unless defined(&fsys_mode);
	    eval 'sub force_successful_syscall_return () {
	        eval q(( &ia64_task_regs( &current)-> &r8 = 0));
	    }' unless defined(&force_successful_syscall_return);
	}
    }
    eval 'sub PT_AUR_RSC () {16;}' unless defined(&PT_AUR_RSC);
    eval 'sub PT_AUR_BSP () {17;}' unless defined(&PT_AUR_BSP);
    eval 'sub PT_AUR_BSPSTORE () {18;}' unless defined(&PT_AUR_BSPSTORE);
    eval 'sub PT_AUR_RNAT () {19;}' unless defined(&PT_AUR_RNAT);
    eval 'sub PT_AUR_CCV () {32;}' unless defined(&PT_AUR_CCV);
    eval 'sub PT_AUR_UNAT () {36;}' unless defined(&PT_AUR_UNAT);
    eval 'sub PT_AUR_FPSR () {40;}' unless defined(&PT_AUR_FPSR);
    eval 'sub PT_AUR_PFS () {64;}' unless defined(&PT_AUR_PFS);
    eval 'sub PT_AUR_LC () {65;}' unless defined(&PT_AUR_LC);
    eval 'sub PT_AUR_EC () {66;}' unless defined(&PT_AUR_EC);
    eval 'sub PTRACE_SINGLEBLOCK () {12;}' unless defined(&PTRACE_SINGLEBLOCK);
    eval 'sub PTRACE_OLD_GETSIGINFO () {13;}' unless defined(&PTRACE_OLD_GETSIGINFO);
    eval 'sub PTRACE_OLD_SETSIGINFO () {14;}' unless defined(&PTRACE_OLD_SETSIGINFO);
    eval 'sub PTRACE_GETREGS () {18;}' unless defined(&PTRACE_GETREGS);
    eval 'sub PTRACE_SETREGS () {19;}' unless defined(&PTRACE_SETREGS);
    eval 'sub PTRACE_OLDSETOPTIONS () {21;}' unless defined(&PTRACE_OLDSETOPTIONS);
}
1;
