require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_SPINLOCK_H)) {
    eval 'sub _ASM_IA64_SPINLOCK_H () {1;}' unless defined(&_ASM_IA64_SPINLOCK_H);
    require 'linux/compiler.ph';
    require 'linux/kernel.ph';
    require 'asm/atomic.ph';
    require 'asm/bitops.ph';
    require 'asm/intrinsics.ph';
    require 'asm/system.ph';
    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
    eval 'sub spin_lock_init {
        local($x) = @_;
	    eval q((($x)-> &lock = 0));
    }' unless defined(&spin_lock_init);
    if(defined(&ASM_SUPPORTED)) {
	eval 'sub IA64_SPINLOCK_CLOBBERS () {"ar.ccv", "ar.pfs", "p14", "r28", "r29", "r30", "b6", "memory";}' unless defined(&IA64_SPINLOCK_CLOBBERS);
	if((defined(&__GNUC__) ? &__GNUC__ : 0) < 3|| ((defined(&__GNUC__) ? &__GNUC__ : 0) == 3 && (defined(&__GNUC_MINOR__) ? &__GNUC_MINOR__ : 0) < 4)) {
	    if(defined(&CONFIG_ITANIUM)) {
	    } else {
	    }
	} else {
	    if(defined(&CONFIG_ITANIUM)) {
	    } else {
	    }
	}
    } else {
	eval 'sub _raw_spin_lock {
	    local($x) = @_;
    	    eval q( &do {  &__u32 * &ia64_spinlock_ptr = ($x);  &__u64  &ia64_spinlock_val;  &ia64_spinlock_val =  &ia64_cmpxchg4_acq( &ia64_spinlock_ptr, 1, 0);  &if ( &unlikely( &ia64_spinlock_val)) {  &do {  &while (* &ia64_spinlock_ptr)  &ia64_barrier();  &ia64_spinlock_val =  &ia64_cmpxchg4_acq( &ia64_spinlock_ptr, 1, 0); }  &while ( &ia64_spinlock_val); } }  &while (0));
	}' unless defined(&_raw_spin_lock);
    }
    eval 'sub spin_is_locked {
        local($x) = @_;
	    eval q((($x)-> &lock != 0));
    }' unless defined(&spin_is_locked);
    eval 'sub _raw_spin_unlock {
        local($x) = @_;
	    eval q( &do {  &barrier(); ( $x)-> &lock = 0; }  &while (0));
    }' unless defined(&_raw_spin_unlock);
    eval 'sub _raw_spin_trylock {
        local($x) = @_;
	    eval q(( &cmpxchg_acq(($x)-> &lock, 0, 1) == 0));
    }' unless defined(&_raw_spin_trylock);
    eval 'sub spin_unlock_wait {
        local($x) = @_;
	    eval q( &do {  &barrier(); }  &while (($x)-> &lock));
    }' unless defined(&spin_unlock_wait);
    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0, 0};}' unless defined(&RW_LOCK_UNLOCKED);
    eval 'sub rwlock_init {
        local($x) = @_;
	    eval q( &do { *($x) =  &RW_LOCK_UNLOCKED; }  &while(0));
    }' unless defined(&rwlock_init);
    eval 'sub rwlock_is_locked {
        local($x) = @_;
	    eval q((* ($x) != 0));
    }' unless defined(&rwlock_is_locked);
    eval 'sub _raw_read_lock {
        local($rw) = @_;
	    eval q( &do {  &rwlock_t * &__read_lock_ptr = ;  &while ( &unlikely( &ia64_fetchadd(1,  &__read_lock_ptr,  &acq) < 0)) {  &ia64_fetchadd(-1,  &__read_lock_ptr,  &rel);  &while (* &__read_lock_ptr < 0)  &cpu_relax(); } }  &while (0));
    }' unless defined(&_raw_read_lock);
    eval 'sub _raw_read_unlock {
        local($rw) = @_;
	    eval q( &do {  &rwlock_t * &__read_lock_ptr = ;  &ia64_fetchadd(-1,  &__read_lock_ptr,  &rel); }  &while (0));
    }' unless defined(&_raw_read_unlock);
    if(defined(&ASM_SUPPORTED)) {
	eval 'sub _raw_write_lock {
	    local($rw) = @_;
    	    eval q( &do {  &__asm__  &__volatile__ ( \\"mov ar.ccv = r0\\\\n\\" \\"dep r29 = -1, r0, 31, 1;;\\\\n\\" \\"1:\\\\n\\" \\"ld4 r2 = [%0];;\\\\n\\" \\"cmp4.eq p0,p7 = r0,r2\\\\n\\" \\" br.cond.spnt.few 1b \\\\n\\" \\"cmpxchg4.acq r2 = [%0], r29, ar.ccv;;\\\\n\\" \\"cmp4.eq p0,p7 = r0, r2\\\\n\\" \\" br.cond.spnt.few 1b;;\\\\n\\" :: \\"r\\"($rw) : \\"ar.ccv\\", \\"p7\\", \\"r2\\", \\"r29\\", \\"memory\\"); }  &while(0));
	}' unless defined(&_raw_write_lock);
	eval 'sub _raw_write_trylock {
	    local($rw) = @_;
    	    eval q(({  &register \'long result\';  &__asm__  &__volatile__ ( \\"mov ar.ccv = r0\\\\n\\" \\"dep r29 = -1, r0, 31, 1;;\\\\n\\" \\"cmpxchg4.acq %0 = [%1], r29, ar.ccv\\\\n\\" : \\"=r\\"( &result) : \\"r\\"($rw) : \\"ar.ccv\\", \\"r29\\", \\"memory\\"); ( &result == 0); }));
	}' unless defined(&_raw_write_trylock);
    } else {
	eval 'sub _raw_write_lock {
	    local($l) = @_;
    	    eval q(({  &__u64  &ia64_val,  &ia64_set_val =  &ia64_dep_mi(-1, 0, 31, 1);  &__u32 * &ia64_write_lock_ptr = ($l);  &do {  &while (* &ia64_write_lock_ptr)  &ia64_barrier();  &ia64_val =  &ia64_cmpxchg4_acq( &ia64_write_lock_ptr,  &ia64_set_val, 0); }  &while ( &ia64_val); }));
	}' unless defined(&_raw_write_lock);
	eval 'sub _raw_write_trylock {
	    local($rw) = @_;
    	    eval q(({  &__u64  &ia64_val;  &__u64  &ia64_set_val =  &ia64_dep_mi(-1, 0, 31,1);  &ia64_val =  &ia64_cmpxchg4_acq(($rw),  &ia64_set_val, 0); ( &ia64_val == 0); }));
	}' unless defined(&_raw_write_trylock);
    }
    eval 'sub _raw_write_unlock {
        local($x) = @_;
	    eval q(({  &smp_mb__before_clear_bit();  &clear_bit(31, ($x)); }));
    }' unless defined(&_raw_write_unlock);
}
1;
