require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_IA64_SYSTEM_H)) {
    eval 'sub _ASM_IA64_SYSTEM_H () {1;}' unless defined(&_ASM_IA64_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/kregs.ph';
    require 'asm/page.ph';
    require 'asm/pal.ph';
    require 'asm/percpu.ph';
    eval 'sub GATE_ADDR () {(0xa000000000000000 +  &PERCPU_PAGE_SIZE);}' unless defined(&GATE_ADDR);
    eval 'sub KERNEL_START () {0xa000000100000000;}' unless defined(&KERNEL_START);
    eval 'sub PERCPU_ADDR () {(- &PERCPU_PAGE_SIZE);}' unless defined(&PERCPU_ADDR);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/kernel.ph';
	require 'linux/types.ph';
	eval 'sub mb () {
	    eval q( &ia64_mf());
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &mb());
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &mb());
	}' unless defined(&wmb);
	eval 'sub read_barrier_depends () {
	    eval q( &do { }  &while(0));
	}' unless defined(&read_barrier_depends);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub smp_mb () {
	        eval q( &mb());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &rmb());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &wmb());
	    }' unless defined(&smp_wmb);
	    eval 'sub smp_read_barrier_depends () {
	        eval q( &read_barrier_depends());
	    }' unless defined(&smp_read_barrier_depends);
	} else {
	    eval 'sub smp_mb () {
	        eval q( &barrier());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_wmb);
	    eval 'sub smp_read_barrier_depends () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&smp_read_barrier_depends);
	}
	eval 'sub set_mb {
	    local($var, $value) = @_;
    	    eval q( &do { ($var) = ($value);  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	eval 'sub set_wmb {
	    local($var, $value) = @_;
    	    eval q( &do { ($var) = ($value);  &mb(); }  &while (0));
	}' unless defined(&set_wmb);
	eval 'sub safe_halt () {
	    eval q( &ia64_pal_halt_light());
	}' unless defined(&safe_halt);
	eval 'sub __local_irq_save {
	    local($x) = @_;
    	    eval q( &do { ($x) =  &ia64_getreg( &_IA64_REG_PSR);  &ia64_stop();  &ia64_rsm( &IA64_PSR_I); }  &while (0));
	}' unless defined(&__local_irq_save);
	eval 'sub __local_irq_disable () {
	    eval q( &do {  &ia64_stop();  &ia64_rsm( &IA64_PSR_I); }  &while (0));
	}' unless defined(&__local_irq_disable);
	eval 'sub __local_irq_restore {
	    local($x) = @_;
    	    eval q( &ia64_intrin_local_irq_restore(($x) &  &IA64_PSR_I));
	}' unless defined(&__local_irq_restore);
	if(defined(&CONFIG_IA64_DEBUG_IRQ)) {
	    eval 'sub __save_ip () {
	        eval q( &last_cli_ip =  &ia64_getreg( &_IA64_REG_IP));
	    }' unless defined(&__save_ip);
	    eval 'sub local_irq_save {
	        local($x) = @_;
    		eval q( &do { \'unsigned long psr\';  &__local_irq_save( &psr);  &if ( &psr &  &IA64_PSR_I)  &__save_ip(); ($x) =  &psr; }  &while (0));
	    }' unless defined(&local_irq_save);
	    eval 'sub local_irq_disable () {
	        eval q( &do { \'unsigned long x\';  &local_irq_save( &x); }  &while (0));
	    }' unless defined(&local_irq_disable);
	    eval 'sub local_irq_restore {
	        local($x) = @_;
    		eval q( &do { \'unsigned long old_psr\',  &psr = ($x);  &local_save_flags( &old_psr);  &__local_irq_restore( &psr);  &if (( &old_psr &  &IA64_PSR_I)  && !( &psr &  &IA64_PSR_I))  &__save_ip(); }  &while (0));
	    }' unless defined(&local_irq_restore);
	} else {
	    eval 'sub local_irq_save {
	        local($x) = @_;
    		eval q( &__local_irq_save($x));
	    }' unless defined(&local_irq_save);
	    eval 'sub local_irq_disable () {
	        eval q( &__local_irq_disable());
	    }' unless defined(&local_irq_disable);
	    eval 'sub local_irq_restore {
	        local($x) = @_;
    		eval q( &__local_irq_restore($x));
	    }' unless defined(&local_irq_restore);
	}
	eval 'sub local_irq_enable () {
	    eval q(({  &ia64_ssm( &IA64_PSR_I);  &ia64_srlz_d(); }));
	}' unless defined(&local_irq_enable);
	eval 'sub local_save_flags {
	    local($flags) = @_;
    	    eval q((($flags) =  &ia64_getreg( &_IA64_REG_PSR)));
	}' unless defined(&local_save_flags);
	eval 'sub irqs_disabled () {
	    eval q(({ \'unsigned long __ia64_id_flags\';  &local_save_flags( &__ia64_id_flags); ( &__ia64_id_flags &  &IA64_PSR_I) == 0; }));
	}' unless defined(&irqs_disabled);
	if(defined(&__KERNEL__)) {
	    eval 'sub prepare_to_switch () {
	        eval q( &do { }  &while(0));
	    }' unless defined(&prepare_to_switch);
	    if(defined(&CONFIG_IA32_SUPPORT)) {
		eval 'sub IS_IA32_PROCESS {
		    local($regs) = @_;
    		    eval q(( &ia64_psr($regs)-> &is != 0));
		}' unless defined(&IS_IA32_PROCESS);
	    } else {
		eval 'sub IS_IA32_PROCESS {
		    local($regs) = @_;
    		    eval q(0);
		}' unless defined(&IS_IA32_PROCESS);
	    }
	    if(defined(&CONFIG_PERFMON)) {
		eval 'sub PERFMON_IS_SYSWIDE () {
		    eval q(( &__get_cpu_var( &pfm_syst_info) & 0x1));
		}' unless defined(&PERFMON_IS_SYSWIDE);
	    } else {
		eval 'sub PERFMON_IS_SYSWIDE () {
		    eval q((0));
		}' unless defined(&PERFMON_IS_SYSWIDE);
	    }
	    eval 'sub IA64_HAS_EXTRA_STATE {
	        local($t) = @_;
    		eval q((($t)-> ($thread->{flags}) & ( &IA64_THREAD_DBG_VALID| &IA64_THREAD_PM_VALID) ||  &IS_IA32_PROCESS( &ia64_task_regs($t)) ||  &PERFMON_IS_SYSWIDE()));
	    }' unless defined(&IA64_HAS_EXTRA_STATE);
	    eval 'sub __switch_to {
	        local($prev,$next,$last) = @_;
    		eval q( &do {  &if ( &IA64_HAS_EXTRA_STATE($prev))  &ia64_save_extra($prev);  &if ( &IA64_HAS_EXTRA_STATE($next))  &ia64_load_extra($next);  &ia64_psr( &ia64_task_regs($next))-> &dfh = ! &ia64_is_local_fpu_owner($next); ($last) =  &ia64_switch_to(($next)); }  &while (0));
	    }' unless defined(&__switch_to);
	    if(defined(&CONFIG_SMP)) {
		eval 'sub switch_to {
		    local($prev,$next,$last) = @_;
    		    eval q( &do {  &if ( &ia64_psr( &ia64_task_regs($prev))-> &mfh) {  &ia64_psr( &ia64_task_regs($prev))-> &mfh = 0; ($prev)-> ($thread->{flags}) |=  &IA64_THREAD_FPH_VALID;  &__ia64_save_fpu(($prev)-> ($thread->{fph})); }  &__switch_to($prev, $next, $last); }  &while (0));
		}' unless defined(&switch_to);
	    } else {
		eval 'sub switch_to {
		    local($prev,$next,$last) = @_;
    		    eval q( &__switch_to($prev, $next, $last));
		}' unless defined(&switch_to);
	    }
	    eval 'sub prepare_arch_switch {
	        local($rq, $next) = @_;
    		eval q( &do {  &spin_lock(($next)-> &switch_lock);  &spin_unlock(($rq)-> &lock); }  &while (0));
	    }' unless defined(&prepare_arch_switch);
	    eval 'sub finish_arch_switch {
	        local($rq, $prev) = @_;
    		eval q( &spin_unlock_irq(($prev)-> &switch_lock));
	    }' unless defined(&finish_arch_switch);
	    eval 'sub task_running {
	        local($rq, $p) = @_;
    		eval q((($rq)-> &curr == ($p) ||  &spin_is_locked(($p)-> &switch_lock)));
	    }' unless defined(&task_running);
	    eval 'sub ia64_platform_is {
	        local($x) = @_;
    		eval q(( &strcmp($x,  &platform_name) == 0));
	    }' unless defined(&ia64_platform_is);
	}
    }
}
1;
